from anuga.utilities.numerical_tools import ensure_numeric
from Scientific.IO.NetCDF import NetCDFFile
from Numeric import asarray,transpose,sqrt,argmax,argmin,arange,Float,\
    compress,zeros,fabs,allclose,ones
from anuga.utilities.polygon import inside_polygon,read_polygon
from os import sep
from time import localtime, strftime, gmtime
from anuga.shallow_water.data_manager import urs2sts,create_sts_boundary
import os
import project

######################################
# Create urs boundary from mux2files #
######################################

dir=os.path.join(project.muxhome,'mux')

# taken from David's event list
urs_filenames = [
    os.path.join(dir,'Java-0000-z.grd'),
    os.path.join(dir,'Java-0001-z.grd'),
    os.path.join(dir,'Java-0002-z.grd'),
    os.path.join(dir,'Java-0003-z.grd'),
    os.path.join(dir,'Java-0005-z.grd'), 
    os.path.join(dir,'Java-0006-z.grd'), 
    os.path.join(dir,'Java-0007-z.grd'), 
    os.path.join(dir,'Java-0008-z.grd'), 
    os.path.join(dir,'Java-0010-z.grd'), 
    os.path.join(dir,'Java-0011-z.grd'), 
    os.path.join(dir,'Java-0012-z.grd'), 
    os.path.join(dir,'Java-0013-z.grd'),  
    os.path.join(dir,'Java-0015-z.grd'),  
    os.path.join(dir,'Java-0016-z.grd'),  
    os.path.join(dir,'Java-0017-z.grd'),  
    os.path.join(dir,'Java-0018-z.grd'),  
    os.path.join(dir,'Java-0020-z.grd'),  
    os.path.join(dir,'Java-0021-z.grd'),  
    os.path.join(dir,'Java-0022-z.grd'),  
    os.path.join(dir,'Java-0023-z.grd'),  
    os.path.join(dir,'Java-0025-z.grd'),  
    os.path.join(dir,'Java-0026-z.grd'),  
    os.path.join(dir,'Java-0027-z.grd'),  
    os.path.join(dir,'Java-0028-z.grd'),  
    os.path.join(dir,'Java-0029-z.grd'),  
    os.path.join(dir,'Java-0030-z.grd'),  
    os.path.join(dir,'Java-0031-z.grd'),  
    os.path.join(dir,'Java-0032-z.grd'),  
    os.path.join(dir,'Java-0033-z.grd'),  
    os.path.join(dir,'Java-0034-z.grd'),  
    os.path.join(dir,'Java-0035-z.grd'),  
    os.path.join(dir,'Java-0036-z.grd'),  
    os.path.join(dir,'Java-0037-z.grd'),  
    os.path.join(dir,'Java-0038-z.grd'),  
    os.path.join(dir,'Java-0039-z.grd'),  
    os.path.join(dir,'Java-0040-z.grd'),  
    os.path.join(dir,'Java-0041-z.grd'),  
    os.path.join(dir,'Java-0042-z.grd'),  
    os.path.join(dir,'Java-0043-z.grd'),  
    os.path.join(dir,'Java-0044-z.grd'),  
    os.path.join(dir,'Java-0045-z.grd'),  
    os.path.join(dir,'Java-0046-z.grd'),  
    os.path.join(dir,'Java-0047-z.grd'),
    os.path.join(dir,'Java-0048-z.grd')]  
 
print 'number of sources', len(urs_filenames)

# AS per David Burbidge email on Friday 4th July the mag 9.3 event
# has 1m worth of slip on each sub fault therefore mutliple each unit
# source by the slip (10.4544) and sum the 44 time series together to
# get the time series for this event at the points on your boundary. 

weight_factor = 10.4544
weights=weight_factor*ones(len(urs_filenames),Float)

scenario_name=project.scenario_name
order_filename=os.path.join(project.boundaries_dir, 'thinned_bounding_order.txt')

print 'reading', order_filename
# Create ordered sts file
print 'creating sts file'

urs2sts(urs_filenames,
        basename_out=os.path.join(project.boundaries_dir,scenario_name),
        ordering_filename=order_filename,
        weights=weights,
        mean_stage=project.tide,
        verbose=True)
